package yrpg.bamp.basedata.plugin.other.task;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.encrypt.Encrypters;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.exception.KDException;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.schedule.executor.AbstractTask;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.util.StringUtils;
import yrpg.bamp.basedata.plugin.util.OtherSysDBConnUtil;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;

public class GetCMSDevItemTask extends AbstractTask {

    @Override
    public void execute(RequestContext requestContext, Map<String, Object> map) throws KDException {

        String host=System.getProperty("yrpg.fi.cmshost");
        String port=System.getProperty("yrpg.fi.cmsport");
        String servicename=System.getProperty("yrpg.fi.cmsservicename");

        String url="jdbc:oracle:thin:@"+host+":"+port+"/"+servicename;
        String user=Encrypters.decode(System.getProperty("yrpg.fi.cmsuser"));
        String password=Encrypters.decode(System.getProperty("yrpg.fi.cmspassword"));

        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
        //设置当前时间为0时区时间
        Date date=new Date();
        Calendar calendar=Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.HOUR_OF_DAY, -8);
        calendar.add(Calendar.DAY_OF_MONTH,-1);
        Date yesterday=calendar.getTime();

        long createorgid=100000L;//创建组织
        DynamicObject createorg=BusinessDataServiceHelper.loadSingle(createorgid,"bos_org");

        //研发项目
        QFilter numberfi= new QFilter("number", QCP.equals,"YFXM");
        QFilter[] filters = new QFilter[]{numberfi};
        DynamicObject group=BusinessDataServiceHelper.loadSingle("bos_assistantdatagroup","id,name,number",filters);

        String ctrlstrategy="6";//控制策略
        String status="C";//数据状态 已审核
        String enable="1";//使用状态 可用

        int isfullget=Integer.valueOf(map.get("isfullget").toString());//是否全量  1 全量
        Date selectdate=null;
        if(map.get("selectdate").toString().length()!=0){
            try {
                selectdate=sdf.parse(map.get("selectdate").toString());  //查询日期
            } catch (ParseException e) {
                throw new RuntimeException(e);
            }
        }

        OtherSysDBConnUtil dbutil = new OtherSysDBConnUtil();
        Connection conn= dbutil.getOrclConnection(url,user,password);

        PreparedStatement headStmt = null;
        ResultSet headRs = null;

        String sql=null;
        if(isfullget==1){//全量更新
            sql="SELECT app.ACTIVITY_NUMBER project_number,app.TEXT39 product_number,app.TEXT31 internal_order,app.STATUS status,app.LAST_UPD last_update FROM AGILE.ACTIVITY_P2P3 app  WHERE app.CLASS = 18022 AND app.SUBCLASS = 2000008831 AND app.DELETE_FLAG = 0";
        }else{
            if(selectdate!=null){//指定日期更新
                sql="SELECT app.ACTIVITY_NUMBER project_number,app.TEXT39 product_number,app.TEXT31 internal_order,app.STATUS status,app.LAST_UPD last_update FROM AGILE.ACTIVITY_P2P3 app WHERE app.CLASS = 18022 AND app.SUBCLASS = 2000008831 AND app.DELETE_FLAG = 0 and TO_DATE(TO_CHAR(app.LAST_UPD,'yyyy-MM-dd'),'yyyy-MM-dd')=to_date('"+sdf.format(selectdate)+"','yyyy-MM-dd')";
            }else{//正常更新(前一天到当前时间)
                sql="SELECT app.ACTIVITY_NUMBER project_number,app.TEXT39 product_number,app.TEXT31 internal_order,app.STATUS status,app.LAST_UPD last_update FROM AGILE.ACTIVITY_P2P3 app WHERE app.CLASS = 18022 AND app.SUBCLASS = 2000008831 AND app.DELETE_FLAG = 0 and app.LAST_UPD>=to_date('"+sdf.format(yesterday)+"','yyyy-MM-dd')";
            }
        }

        try {
            headStmt = conn.prepareStatement(sql, ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
            //返回执行结果
            headRs = headStmt.executeQuery();
            while(headRs.next()){
                String number = headRs.getString("project_number");  //项目编码
                String product_number=headRs.getString("product_number"); //品种编码
                String name="";//项目名称
                if(StringUtils.isEmpty(product_number)){
                    name = headRs.getString("project_number");
                }else{
                    name = headRs.getString("project_number")+"("+product_number+")";
                }
                String proortaskstatus = headRs.getString("status"); //项目/任务状态
                String internalorder = headRs.getString("internal_order");  //内部订单号
                numberfi= new QFilter("number", QCP.equals,number);
                filters = new QFilter[]{numberfi};
                DynamicObject ssistantdatadetail=BusinessDataServiceHelper.loadSingle("bos_assistantdata_detail","name,yrpg_proortaskstatus,yrpg_internal_order",filters);

                if(ssistantdatadetail!=null){//已存在更新内容
                    ssistantdatadetail.set("name",name);
                    ssistantdatadetail.set("yrpg_proortaskstatus",proortaskstatus);
                    ssistantdatadetail.set("yrpg_internal_order",internalorder);
                    SaveServiceHelper.update(ssistantdatadetail);
                }else{//不存在新增
                    DynamicObject asddetailBillInfo = BusinessDataServiceHelper.newDynamicObject("bos_assistantdata_detail");
                    ORM.create().setPrimaryKey(asddetailBillInfo);

                    asddetailBillInfo.set("number",number);
                    asddetailBillInfo.set("name",name);
                    asddetailBillInfo.set("level",1);
                    asddetailBillInfo.set("group",group);
                    asddetailBillInfo.set("createorg",createorg);
                    asddetailBillInfo.set("ctrlstrategy",ctrlstrategy);
                    asddetailBillInfo.set("status",status);
                    asddetailBillInfo.set("enable",enable);
                    asddetailBillInfo.set("yrpg_proortaskstatus",proortaskstatus);
                    asddetailBillInfo.set("yrpg_internal_order",internalorder);

                    OperateOption option = OperateOption.create();
                    OperationResult result = OperationServiceHelper.executeOperate("save", "bos_assistantdata_detail", new DynamicObject[]{asddetailBillInfo}, option);
                    boolean success = result.isSuccess();
                    /*if (!success) {
                        SaveIFSLogHelper.saveLog(fwtu_srckey,"recbill",result.getAllErrorOrValidateInfo().toString());
                    }*/

                }
            }
        } catch (SQLException e1) {
            throw new RuntimeException(e1);
        } finally {
            //释放资源
            if (headRs != null) {
                try {
                    headRs.close();
                } catch (SQLException e1) {
                }
            }

            if (headStmt != null) {
                try {
                    headStmt.close();
                } catch (SQLException e1) {
                }
            }
            if (conn != null) {
                try {
                    conn.close();
                } catch (SQLException e1) {
                }
            }
        }
    }
}
